#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	gcc
Version		:	13.2.0
Release		:	14.4.0.0%{dist}
Summary		:	C, C++ compiler
Group		:	Development/Languages

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv3+ and GPLv3+ with exceptions and GPLv2+ with exceptions and LGPLv2+ and BSD
URL		:	http://gcc.gnu.org

Source0		:	%{name}-%{version}.tar.xz
#-----------------------------------------------------------------------------
BuildRequires	:	binutils
BuildRequires	:	bison
BuildRequires	:	dejagnu
BuildRequires	:	flex
BuildRequires	:	gcc
BuildRequires	:	gcc-c++
BuildRequires	:	gmp
BuildRequires	:	isl-devel
BuildRequires	:	linux-headers
BuildRequires	:	m4
BuildRequires	:	make
BuildRequires	:	mpfr
BuildRequires	:	mpc
BuildRequires	:	texinfo
BuildRequires	:	xz
BuildRequires	:	xz-devel

Requires	:	cpp		= %{version}-%{release}
Requires	:	libgcc		= %{version}-%{release}
Requires	:	libstdc++	= %{version}-%{release}
Requires	:	libgomp		= %{version}-%{release}


Requires	:	libasan		= %{version}-%{release}
Requires	:	libquadmath	= %{version}-%{release}
Requires	:	libtsan		= %{version}-%{release}
#-----------------------------------------------------------------------------
%description
The GNU Compiler Collection includes front ends for C, C++, as well as
libraries for these languages (libstdc++,...). GCC was originally written
as the compiler for the GNU operating system. The GNU system was developed to
be 100% free software, free in the sense that it respects the user's freedom.

#-----------------------------------------------------------------------------
%files					-f %{name}.lang
%defattr(-,root,root,-)
%{_includedir}/*
%{_bindir}/cc
%{_bindir}/gcc
%{_bindir}/gcc-ar
%{_bindir}/gcc-nm
%{_bindir}/gcc-ranlib
%{_bindir}/gcov
%{_bindir}/gcov-dump
%{_bindir}/lto-dump
%{_bindir}/gcov-tool
%{_bindir}/%{_target_platform}-*
%exclude %{_libdir}/libgcc_s.so.1
%exclude %{_libdir}/libstdc++.so.6*
%exclude %{_libdir}/libgomp.so.1*
%exclude %{_libdir}/libquadmath.so.0*
%exclude %{_libdir}/libasan.so.8*
%exclude %{_libdir}/libtsan.so.2*
%{_libdir}/lib*
%{_libdir}/gcc/*
%{_libdir}/bfd-plugins/*.so
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/collect2
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/lto1
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/lto-wrapper
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/liblto_plugin.so*
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/install-tools/*
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/plugin/gengtype
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/g++-mapper-server
%{_infodir}/gcc*.info.gz
%{_datadir}/gdb/auto-load%{_libdir}/*
%{_datadir}/%{name}-%{version}/*
%{_infodir}/libitm.info.gz
%{_mandir}/man1/%{name}.1.gz
%{_mandir}/man1/gcov.1.gz
%{_mandir}/man1/gcov-tool.1.gz
%{_mandir}/man1/gcov-dump.1.gz
%{_mandir}/man1/lto-dump.1.gz
%{_mandir}/man7/*.7.gz

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig

#=============================================================================
%package 		c++
Summary		:	C++ support for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}
Requires	:	libstdc++	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description 		 c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

#-----------------------------------------------------------------------------
%files 			c++
%defattr(-,root,root,-)
%{_bindir}/c++
%{_bindir}/g++
%{_bindir}/%{_target_platform}-c++
%{_bindir}/%{_target_platform}-g++
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/cc1plus
%{_mandir}/man1/g++.1.gz

#=============================================================================
%package -n		libgcc
Summary		:	GCC version 4.4 shared support library

#-----------------------------------------------------------------------------
Requires(post)	:	/usr/sbin/ldconfig
Requires(postun):	/usr/sbin/ldconfig

Requires	:	readline
#-----------------------------------------------------------------------------
%description -n		 libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.

#-----------------------------------------------------------------------------
%files -n		libgcc
%defattr(-,root,root,-)
%{_libdir}/libgcc_s.so.1
%doc COPYING.LIB

#-----------------------------------------------------------------------------
%postun -n		libgcc
/usr/sbin/ldconfig

%post -n 		libgcc
/usr/sbin/ldconfig

#=============================================================================
%package -n		libstdc++
Summary		:	GNU Standard C++ Library

#-----------------------------------------------------------------------------
Requires(post)	:	/usr/sbin/ldconfig
Requires(postun):	/usr/sbin/ldconfig
Requires	:	glibc

#-----------------------------------------------------------------------------
%description -n		libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

#-----------------------------------------------------------------------------
%files -n		libstdc++	-f libstdc++.lang
%defattr(-,root,root,-)
%{_libdir}/libstdc++.so.6*

#-----------------------------------------------------------------------------
%postun -n		libstdc++
/usr/sbin/ldconfig

%post -n		libstdc++
/usr/sbin/ldconfig

#=============================================================================
%package -n		cpp
Summary		:	The C Preprocessor

#-----------------------------------------------------------------------------
%description -n		cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

#-----------------------------------------------------------------------------
%files -n		cpp		-f cpplib.lang
%defattr(-,root,root,-)
%{_bindir}/cpp
/lib/cpp
%{_libexecdir}/%{name}/%{_target_platform}/%{version}/cc1
%{_infodir}/cpp.info.gz
%{_infodir}/cppinternals.info.gz
%{_mandir}/man1/cpp.1.gz

#=============================================================================
%package -n		libgomp
Summary		:	GCC OpenMP v4.5 shared support library

#-----------------------------------------------------------------------------
%description -n		libgomp
This package contains GCC shared support library which is needed
for OpenMP v4.5 support.

#-----------------------------------------------------------------------------
%files -n		libgomp
%defattr(-,root,root,-)
%{_libdir}/libgomp.so.1*
%{_infodir}/libgomp.info.gz

#-----------------------------------------------------------------------------
%postun -n		libgomp
/usr/sbin/ldconfig

%post -n		libgomp
/usr/sbin/ldconfig

#=============================================================================
%package -n		libquadmath
Summary		:	GCC __float128 shared support library

#-----------------------------------------------------------------------------
%description -n		libquadmath
This package contains GCC shared support library which is needed
for __float128 math support and for Fortran REAL*16 support.

#-----------------------------------------------------------------------------
%files -n		libquadmath
%defattr(-,root,root,-)
%{_libdir}/libquadmath.so.0*
%{_infodir}/libquadmath.info.gz

#-----------------------------------------------------------------------------
%postun -n		libquadmath
/usr/sbin/ldconfig

%post -n		libquadmath
/usr/sbin/ldconfig

#=============================================================================
%package -n		libasan
Summary		:	The Address Sanitizer runtime library

#-----------------------------------------------------------------------------
%description -n		libasan
This package contains the Address Sanitizer library
which is used for -fsanitize=address instrumented programs.

#-----------------------------------------------------------------------------
%files -n		libasan
%defattr(-,root,root,-)
%{_libdir}/libasan.so.8*

#-----------------------------------------------------------------------------
%postun -n		libasan
/usr/sbin/ldconfig

%post -n		libasan
/usr/sbin/ldconfig

#=============================================================================
%package -n		libtsan
Summary		:	The Thread Sanitizer runtime library

#-----------------------------------------------------------------------------
%description -n		libtsan
This package contains the Thread Sanitizer library
which is used for -fsanitize=thread instrumented programs.

#-----------------------------------------------------------------------------
%files -n		libtsan
%defattr(-,root,root,-)
%{_libdir}/libtsan.so.2*

#-----------------------------------------------------------------------------
%postun -n		libtsan
/usr/sbin/ldconfig

%post -n		libtsan
/usr/sbin/ldconfig

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build
%define _build %(gcc -dumpmachine)
%define _libgcc %{_prefix}/%(gcc -print-multi-os-directory | cut -d '/' -f2)

case "$(uname -m)" in
  "x86_64"	)
    sed -i						\
	-e '/m64=/s/lib64/lib/'				\
        gcc/config/i386/t-linux64
    ;;
  esac

sed -i							\
  -e "/static.*SIGSTKSZ/d" 				\
  -e "s/return kAltStackSize/return SIGSTKSZ * 4/"	\
  libsanitizer/sanitizer_common/sanitizer_posix_libcdep.cpp


mkdir build
pushd build
SED=sed							\
../configure						\
	--build=%{_build}				\
        --prefix=%{_prefix}				\
	--libdir=%{_libdir}				\
	--mandir=%{_mandir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-languages=c,c++			\
	--enable-shared					\
	--enable-linker-build-id			\
	--disable-multilib				\
	--with-system-zlib				\
	--disable-bootstrap				\
	--with-isl=%{_prefix}				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install

%{__rm} -rf %{buildroot}
%{__make} -C build DESTDIR=%{buildroot} install
%{__rm} -fr %{buildroot}%{_infodir}/dir

#Create a symlink required by the FHS for "historical" reasons. 
%{__mkdir_p} %{buildroot}/lib
ln -s ../usr/bin/cpp %{buildroot}/lib

#Many packages use the name cc to call the C compiler. To satisfy those packages, create a symlink:
ln -s gcc  %{buildroot}/%{_bindir}/cc

#Add a compatibility symlink to enable building programs with Link Time Optimization (LTO) 
install -dm755 %{buildroot}%{_libdir}/bfd-plugins
%{__ln_s} -f						\
	../../libexec/gcc/$(gcc -dumpmachine)/%{version}/liblto_plugin.so	\
	%{buildroot}%{_libdir}/bfd-plugins

#Finally, move a misplaced file
%{__mkdir_p}	%{buildroot}%{_datadir}/gdb/auto-load%{_libdir}
%{__mv} 						\
	%{buildroot}%{_libdir}/*gdb.py			\
	%{buildroot}%{_datadir}/gdb/auto-load%{_libdir}

chmod 755 %{buildroot}/%{_libdir}/libgcc_s.so.1

#moving libgcc in the right spot
#mkdir -p %{buildroot}/%{_lib}
#%{__mv} -f %{buildroot}%{_libdir}/libgcc_s.so.1 %{buildroot}/%{_lib}
#%{__ln_s} -f							\
#	./libgcc_s.so.1						\
#	%{buildroot}/%{_lib}/libgcc_s-%{version}-%{release}.so.1


#to extract lang local messages
%find_lang %{name}
%find_lang cpplib
%find_lang libstdc++

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	%{buildroot}%{_libexecdir}			\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
